=== debian/changelog ===
deal.ii (8.1.0-6ubuntu1) xenial; urgency=medium

  * Use -fPIC instead of -fpic to fix FTBFS on arm64, thanks Matthias Klose.

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 01 Apr 2016 08:04:21 +0200

deal.ii (8.1.0-6) unstable; urgency=medium

  * Revert fix for doxygen deal.tag since it moved back
  * Use secure URIs for VCS fields
  * Migrate from libdeal.ii-dbg to ddebs, bump debhelper build-dependency
  * Update obsolete source URL in debian/copyright
  * Bump Standards-Version to 3.9.7, no further changes

 -- Graham Inggs <ginggs@debian.org>  Wed, 16 Mar 2016 12:33:02 +0200

deal.ii (8.1.0-5) unstable; urgency=medium

  * Fix FTBFS due to doxygen deal.tag moving (Closes: #789975)
  * Use an explicit cast to fix FTBFS with new boost and c++11
  * Update debian/watch
  * Enable cryptographic signature verification
  * Add myself to uploaders

 -- Graham Inggs <ginggs@debian.org>  Wed, 16 Sep 2015 21:44:26 +0200

deal.ii (8.1.0-4) unstable; urgency=medium

  * Fix broken build dependencies for buildds
  * Fix imprecision in copyright file

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Fri, 18 Apr 2014 13:38:16 +0200

deal.ii (8.1.0-3) unstable; urgency=medium

  * Fix privacy breaches in html documentation v2.

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Mon, 03 Mar 2014 13:37:27 +0100

deal.ii (8.1.0-2) unstable; urgency=medium

  * Add forgotten copyright notice for a file under doc/external-libs/.
  * Add a watch file.
  * Fix short description for dbg, dev and doc package.
  * Fix privacy breaches in html documentation.
  * Remove empty directories from documentation.
  * Rename shared libraries to libdeal.ii[.g].so to match package name.
  * Change library name to match package name.
  * Do not compress example source code.
  * Reogranize patches.

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Sat, 01 Mar 2014 19:38:47 +0100

deal.ii (8.1.0-1) unstable; urgency=medium

  * Initial release.

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Fri, 03 Jan 2014 20:52:34 +0100
