=== debian/control ===
Source: deal.ii
Section: libs
Priority: optional
Standards-Version: 3.9.7
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>, Graham Inggs <ginggs@debian.org>
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/deal.ii.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/deal.ii.git
Homepage: http://www.dealii.org/
Build-Depends: debhelper (>= 9.20150628), cmake, doxygen, graphviz,
 liblapack-dev, libsuitesparse-dev, libtbb-dev, libboost-iostreams-dev,
 libboost-serialization-dev, libboost-system-dev, libboost-thread-dev, zlib1g-dev

Package: libdeal.ii-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libdeal.ii-8.1.0 (= ${binary:Version}),
 liblapack-dev, libsuitesparse-dev, libtbb-dev, libboost-iostreams-dev,
 libboost-serialization-dev, libboost-system-dev, libboost-thread-dev, zlib1g-dev
Recommends: cmake
Description: Differential Equations Analysis Library - development files
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the development files.

Package: libdeal.ii-8.1.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Finite Element Differential Equations Analysis Library
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the shared libraries.

Package: libdeal.ii-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Differential Equations Analysis Library - html doc. and examples
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the documentation and examples.
