=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/,filenamemangle=s/.+\/dealii-(\d\S*)\.tar\.gz/deal\.ii-$1\.tar\.gz/ \
https://github.com/dealii/dealii/releases .*/dealii-(\d+\.\d+\.\d+)\.tar\.gz
